Index: protocol/src/main/java/geniusweb/protocol/NegoSettings.java
===================================================================
--- protocol/src/main/java/geniusweb/protocol/NegoSettings.java	(revision 30)
+++ protocol/src/main/java/geniusweb/protocol/NegoSettings.java	(revision 31)
@@ -5,10 +5,8 @@
 import com.fasterxml.jackson.annotation.JsonSubTypes;
 import com.fasterxml.jackson.annotation.JsonSubTypes.Type;
+import com.fasterxml.jackson.annotation.JsonTypeInfo;
 
 import geniusweb.protocol.session.SessionSettings;
 import geniusweb.protocol.tournament.TournamentSettings;
-
-import com.fasterxml.jackson.annotation.JsonTypeInfo;
-
 import tudelft.utilities.logging.Reporter;
 
@@ -36,5 +34,5 @@
 	/**
 	 * @param logger the logger where the protocol can log events to.
-	 * @return the an initialized and ready to use {@link NegoProtocol} that can
+	 * @return an initialized and ready to use {@link NegoProtocol} that can
 	 *         handle this Negotiation.
 	 */
Index: protocol/src/main/java/geniusweb/protocol/session/DefaultSessionState.java
===================================================================
--- protocol/src/main/java/geniusweb/protocol/session/DefaultSessionState.java	(revision 30)
+++ protocol/src/main/java/geniusweb/protocol/session/DefaultSessionState.java	(revision 31)
@@ -1,5 +1,8 @@
 package geniusweb.protocol.session;
 
+import java.util.ArrayList;
 import java.util.Collections;
+import java.util.HashMap;
+import java.util.HashSet;
 import java.util.LinkedList;
 import java.util.List;
@@ -10,32 +13,29 @@
 import geniusweb.progress.Progress;
 import geniusweb.protocol.ProtocolException;
-import geniusweb.protocol.partyconnection.ProtocolToPartyConnections;
 import geniusweb.references.PartyWithProfile;
 
 /**
+ * 
+ */
+/**
+ * 
  * The default current state of the session. immutable.
+ * 
+ * @param <P> the actual SessionState object
+ * @param <S> the actual SessionSettings object
  */
-public abstract class DefaultSessionState implements SessionState {
+public abstract class DefaultSessionState<P extends DefaultSessionState<P, S>, S extends SessionSettings>
+		implements SessionState {
 	private final List<Action> actions;
 
-	private final transient ProtocolToPartyConnections connections;
+	private final List<PartyId> connections;
 
 	private final Progress progress;
 
-	private final SessionSettings settings;
+	private final S settings;
 
 	private final ProtocolException error;
 
 	private final Map<PartyId, PartyWithProfile> partyprofiles;
-
-	// only for deserializer.
-	protected DefaultSessionState() {
-		actions = null;
-		connections = null;
-		progress = null;
-		settings = null;
-		partyprofiles = null;
-		error = null;
-	}
 
 	/**
@@ -59,14 +59,14 @@
 	 *                      result in a throw and terminate the session.
 	 */
-	public DefaultSessionState(List<Action> actions,
-			ProtocolToPartyConnections conns, Progress progr,
-			SessionSettings settings,
+	public DefaultSessionState(List<Action> actions, List<PartyId> conns,
+			Progress progr, S settings,
 			Map<PartyId, PartyWithProfile> partyprofiles, ProtocolException e) {
 		if (partyprofiles == null) {
-			partyprofiles = Collections.emptyMap();
+			this.partyprofiles = Collections.emptyMap();
+		} else {
+			this.partyprofiles = partyprofiles;
 		}
 		if (conns == null) {
-			this.connections = new ProtocolToPartyConnections(
-					Collections.emptyList());
+			this.connections = Collections.emptyList();
 		} else {
 			this.connections = conns;
@@ -78,19 +78,41 @@
 		}
 
-		if (!connections.allunique()) {
+		if (connections.size() != new HashSet<PartyId>(connections).size()) {
 			throw new IllegalArgumentException(
 					"There can not be multiple connections for a party:"
 							+ connections);
 		}
+		if (settings == null)
+			throw new IllegalArgumentException("Settings must be not null");
 		this.progress = progr;
 		this.settings = settings;
-		this.partyprofiles = partyprofiles;
 		this.error = e;
 	}
 
 	/**
+	 * Construct a new session state, where the DefaultSessionState changes
+	 * while the rest of the state remains unchanged. Notice the return type P.
+	 * 
+	 * @param actions1       the new {@link Action}s
+	 * @param conns          the new connected {@link PartyId}s
+	 * @param progress1      the new {@link Progress}
+	 * @param settings1      the new {@link SessionSettings}. Normally this is
+	 *                       constant during a session.
+	 * @param partyprofiles1 the new {@link PartyWithProfile}s for all parties.
+	 *                       Normally this remains constant during a session.
+	 * @param e              an error that occured that caused the session to
+	 *                       reach its terminated/final state. If an error does
+	 *                       not cause termination, only a warning should be
+	 *                       logged.
+	 * @return the new state of the derived sessionstate.
+	 */
+	abstract public P with(List<Action> actions1, List<PartyId> conns,
+			Progress progress1, S settings1,
+			Map<PartyId, PartyWithProfile> partyprofiles1, ProtocolException e);
+
+	/**
 	 * @return existing connections.
 	 */
-	public ProtocolToPartyConnections getConnections() {
+	public List<PartyId> getConnections() {
 		return connections;
 	}
@@ -120,5 +142,5 @@
 
 	@Override
-	public SessionSettings getSettings() {
+	public S getSettings() {
 		return settings;
 	}
@@ -137,6 +159,86 @@
 	public String toString() {
 		return this.getClass().getSimpleName() + "[" + actions + ","
-				+ connections + "," + progress + "," + settings + "," + error
-				+ "]";
+				+ connections + "," + progress + "," + settings + "," + error;
+	}
+
+	public P withDeadlineReached() {
+		return with(actions, connections, progress, settings, partyprofiles,
+				error);
+	}
+
+	public P withoutParty(PartyId party) {
+		List<PartyId> newconn = new ArrayList<>(connections);
+		newconn.remove(party);
+		return with(actions, newconn, progress, settings, partyprofiles, error);
+	}
+
+	/**
+	 * 
+	 * @param e the error that occured
+	 * @return a new state with the error set/updated.
+	 */
+	public P with(ProtocolException e) {
+		return with(actions, connections, progress, settings, partyprofiles, e);
+	}
+
+	public P with(PartyId connection, PartyWithProfile partyprofile) {
+		List<PartyId> newconns = new ArrayList<>(getConnections());
+		newconns.add(connection);
+		Map<PartyId, PartyWithProfile> newprofiles = new HashMap<>(
+				getPartyProfiles());
+		newprofiles.put(connection, partyprofile);
+		return with(getActions(), newconns, getProgress(), getSettings(),
+				newprofiles, null);
+	}
+
+	/**
+	 * Sets the new progress for this session.
+	 * 
+	 * @param newprogress the new progress
+	 * @return new SAOPState with the progress set to new value
+	 */
+	public P with(Progress newprogress) {
+		if (newprogress == null) {
+			throw new IllegalArgumentException("newprogress must be not null");
+		}
+		return with(actions, connections, newprogress, settings, partyprofiles,
+				error);
+	}
+
+	/**
+	 * @param actor  the actor that did this action. Can be used to check if
+	 *               action is valid. NOTICE caller has to make sure the current
+	 *               state is not final.
+	 * @param action the action that was proposed by actor.
+	 * @return new SAOPState with the action added as last action.
+	 */
+
+	public P with(PartyId actor, Action action) {
+		String msg = checkAction(actor, action);
+		if (msg != null)
+			throw new IllegalArgumentException(msg);
+
+		List<Action> newactions = new LinkedList<>(getActions());
+		newactions.add(action);
+		return with(newactions, connections, progress, settings, partyprofiles,
+				error);
+	}
+
+	/**
+	 * 
+	 * @param actor  the known real actor that did this action
+	 * @param action an {@link Action}
+	 * @return null if action seems ok, or message explaining why not.
+	 */
+	public String checkAction(PartyId actor, Action action) {
+		if (actor == null) { // this is a bug
+			return "actor must not be null";
+		}
+		if (action == null) {
+			return "action is null";
+		}
+		if (!actor.equals(action.getActor()))
+			return "act contains wrong credentials: " + action;
+		return null;
 	}
 
Index: protocol/src/main/java/geniusweb/protocol/session/SessionSettings.java
===================================================================
--- protocol/src/main/java/geniusweb/protocol/session/SessionSettings.java	(revision 30)
+++ protocol/src/main/java/geniusweb/protocol/session/SessionSettings.java	(revision 31)
@@ -7,9 +7,9 @@
 import geniusweb.protocol.NegoSettings;
 import geniusweb.protocol.session.amop.AMOPSettings;
+import geniusweb.protocol.session.learn.LearnSettings;
 import geniusweb.protocol.session.mopac.MOPACSettings;
 import geniusweb.protocol.session.mopac2.MOPAC2Settings;
 import geniusweb.protocol.session.saop.SAOPSettings;
 import geniusweb.protocol.session.shaop.SHAOPSettings;
-import geniusweb.protocol.tournament.allpermutations.Team;
 import geniusweb.references.PartyWithProfile;
 import tudelft.utilities.logging.Reporter;
@@ -22,9 +22,10 @@
 		@JsonSubTypes.Type(value = AMOPSettings.class),
 		@JsonSubTypes.Type(value = MOPACSettings.class),
-		@JsonSubTypes.Type(value = MOPAC2Settings.class) })
+		@JsonSubTypes.Type(value = MOPAC2Settings.class),
+		@JsonSubTypes.Type(value = LearnSettings.class) })
 public interface SessionSettings extends NegoSettings {
 
 	/**
-	 * Get the {@link Team}s.
+	 * Get the {@link TeamInfo}s.
 	 * 
 	 * @return list of {@link PartyWithProfile} items.
@@ -33,7 +34,7 @@
 
 	/**
-	 * @return the size of each {@link Team}. Usually 1 (SAOP etc) or sometimes
-	 *         2 (SHAOP). Used eg by tournament runner to determine proper team
-	 *         construction.
+	 * @return the size of each {@link TeamInfo}. Usually 1 (SAOP etc) or
+	 *         sometimes 2 (SHAOP). Used eg by tournament runner to determine
+	 *         proper team construction.
 	 */
 	Integer getTeamSize();
Index: protocol/src/main/java/geniusweb/protocol/session/SessionState.java
===================================================================
--- protocol/src/main/java/geniusweb/protocol/session/SessionState.java	(revision 30)
+++ protocol/src/main/java/geniusweb/protocol/session/SessionState.java	(revision 31)
@@ -10,4 +10,5 @@
 import geniusweb.protocol.NegoState;
 import geniusweb.protocol.session.amop.AMOPState;
+import geniusweb.protocol.session.learn.LearnState;
 import geniusweb.protocol.session.mopac.MOPACState;
 import geniusweb.protocol.session.saop.SAOPState;
@@ -33,5 +34,6 @@
 		@JsonSubTypes.Type(value = SHAOPState.class),
 		@JsonSubTypes.Type(value = AMOPState.class),
-		@JsonSubTypes.Type(value = MOPACState.class) })
+		@JsonSubTypes.Type(value = MOPACState.class),
+		@JsonSubTypes.Type(value = LearnState.class) })
 public interface SessionState extends NegoState {
 
Index: protocol/src/main/java/geniusweb/protocol/session/TeamInfo.java
===================================================================
--- protocol/src/main/java/geniusweb/protocol/session/TeamInfo.java	(revision 30)
+++ protocol/src/main/java/geniusweb/protocol/session/TeamInfo.java	(revision 31)
@@ -1,7 +1,9 @@
 package geniusweb.protocol.session;
 
+import java.util.ArrayList;
 import java.util.Arrays;
 import java.util.Collections;
 import java.util.List;
+import java.util.stream.Collectors;
 
 import com.fasterxml.jackson.annotation.JsonAutoDetect;
@@ -11,4 +13,6 @@
 import com.fasterxml.jackson.annotation.JsonTypeInfo;
 
+import geniusweb.protocol.tournament.Team;
+import geniusweb.references.Parameters;
 import geniusweb.references.PartyWithParameters;
 import geniusweb.references.PartyWithProfile;
@@ -23,5 +27,5 @@
 public class TeamInfo {
 
-	private List<PartyWithProfile> parties;
+	private final List<PartyWithProfile> parties;
 
 	/**
@@ -86,3 +90,27 @@
 		return true;
 	}
+
+	/**
+	 * @param parameters a set of {@link Parameters} to be merged with the
+	 *                   existing parameters of the first team member.
+	 * @return updated TeamInfo
+	 */
+	public TeamInfo with(Parameters parameters) {
+		List<PartyWithProfile> updatedparties = new ArrayList<>(parties);
+		PartyWithProfile party1 = updatedparties.get(0);
+		Parameters newparams1 = party1.getParty().getParameters()
+				.with(parameters);
+		PartyWithProfile party1update = new PartyWithProfile(
+				party1.getParty().with(newparams1), party1.getProfile());
+		updatedparties.set(0, party1update);
+		return new TeamInfo(updatedparties);
+	}
+
+	/**
+	 * @return the Team, without the profiles
+	 */
+	public Team getTeam() {
+		return new Team(parties.stream().map(pwithp -> pwithp.getParty())
+				.collect(Collectors.toList()));
+	}
 }
Index: protocol/src/main/java/geniusweb/protocol/session/amop/AMOP.java
===================================================================
--- protocol/src/main/java/geniusweb/protocol/session/amop/AMOP.java	(revision 30)
+++ protocol/src/main/java/geniusweb/protocol/session/amop/AMOP.java	(revision 31)
@@ -48,8 +48,8 @@
  * specified initially in the settings do participate.
  * 
- * <h1>parameter</h1> AMOP parties can receive a parameter: minVotes containing
+ * <h2>parameter</h2> AMOP parties can receive a parameter: minVotes containing
  * a Double. If set, the AMOP protocol checks that all {@link Votes} from that
  * party have {@link Vote#getMinPower()} &gt; minVotes.
- * <h1>Protocol steps</h1>
+ * <h2>Protocol steps</h2>
  * <ol>
  * <li>The protocol tries to start all parties. If not all parties start, the
Index: protocol/src/main/java/geniusweb/protocol/session/learn/Learn.java
===================================================================
--- protocol/src/main/java/geniusweb/protocol/session/learn/Learn.java	(revision 31)
+++ protocol/src/main/java/geniusweb/protocol/session/learn/Learn.java	(revision 31)
@@ -0,0 +1,310 @@
+package geniusweb.protocol.session.learn;
+
+import java.io.IOException;
+import java.sql.Date;
+import java.text.SimpleDateFormat;
+import java.util.Collections;
+import java.util.List;
+import java.util.Timer;
+import java.util.TimerTask;
+import java.util.concurrent.atomic.AtomicBoolean;
+import java.util.logging.Level;
+import java.util.stream.Collectors;
+
+import geniusweb.actions.Action;
+import geniusweb.actions.PartyId;
+import geniusweb.deadline.Deadline;
+import geniusweb.events.ProtocolEvent;
+import geniusweb.inform.Finished;
+import geniusweb.inform.Inform;
+import geniusweb.inform.Settings;
+import geniusweb.progress.ProgressFactory;
+import geniusweb.protocol.CurrentNegoState;
+import geniusweb.protocol.NegoState;
+import geniusweb.protocol.ProtocolException;
+import geniusweb.protocol.partyconnection.ProtocolToPartyConn;
+import geniusweb.protocol.partyconnection.ProtocolToPartyConnFactory;
+import geniusweb.protocol.partyconnection.ProtocolToPartyConnections;
+import geniusweb.protocol.session.SessionProtocol;
+import geniusweb.references.Parameters;
+import geniusweb.references.PartyWithProfile;
+import geniusweb.references.ProfileRef;
+import geniusweb.references.ProtocolRef;
+import geniusweb.references.Reference;
+import tudelft.utilities.listener.DefaultListenable;
+import tudelft.utilities.logging.Reporter;
+import tudelft.utilities.repository.NoResourcesNowException;
+
+/**
+ * The Learn protocol allows parties to learn until the deadline set in the
+ * {@link LearnSettings}.
+ */
+public class Learn extends DefaultListenable<ProtocolEvent>
+		implements SessionProtocol {
+	public static final int MIN_SLEEP_TIME = 1000;
+	public static final int MAX_SLEEP_TIME = 60000;
+	public static final int TIME_MARGIN = 20;// ms extra delay after deadline
+	private LearnState state;
+	private final Reporter log;
+	private static final ProtocolRef LEARN = new ProtocolRef("Learn");
+	private volatile Timer deadlinetimer = null;
+	private volatile AtomicBoolean isFinishedInfoSent = new AtomicBoolean(
+			false);
+	private volatile ProtocolToPartyConnections conns = new ProtocolToPartyConnections(
+			Collections.emptyList());
+
+	public Learn(LearnState state, Reporter logger) {
+		this.state = state;
+		this.log = logger;
+	}
+
+	@Override
+	public void start(ProtocolToPartyConnFactory connectionfactory) {
+		try {
+			connect(connectionfactory);
+			setDeadline();
+			setupParties();
+		} catch (Throwable e) {
+			handleError("Failed to start up session", null, e);
+		}
+
+	}
+
+	@Override
+	public String getDescription() {
+		return "Sends all parties a ";
+	}
+
+	@Override
+	public NegoState getState() {
+		return state;
+	}
+
+	@Override
+	public ProtocolRef getRef() {
+		return LEARN;
+	}
+
+	@Override
+	public void addParticipant(PartyWithProfile party) {
+		throw new IllegalStateException(
+				"Dynamic joining a negotiation is not allowed in LEARN");
+	}
+
+	/*******************************************************************
+	 * private functions. Some are protected only, for testing purposes
+	 ********************************************************************/
+	/**
+	 * step 1 in protocol: connect all involved parties and start the clock.
+	 * This always "succeeds" with a valid (but possibly final) state
+	 * <p>
+	 * This is 'protected' to allow junit testing, this code is not a 'public'
+	 * part of the interface.
+	 * 
+	 * @param connectionfactory the connectionfactory for making party
+	 *                          connections
+	 * 
+	 * @throws InterruptedException if the connection procedure is unterrupted
+	 * 
+	 * @throws IOException          if this fails to properly conect to the
+	 *                              parties, eg interrupted or server not
+	 *                              responding..
+	 */
+	protected synchronized void connect(
+			ProtocolToPartyConnFactory connectionfactory)
+			throws InterruptedException, IOException {
+		List<PartyWithProfile> participants = state.getSettings()
+				.getAllParties();
+		List<Reference> parties = participants.stream()
+				.map(parti -> (parti.getParty().getPartyRef()))
+				.collect(Collectors.toList());
+		List<ProtocolToPartyConn> connections = null;
+		log.log(Level.INFO, "SAOP connect " + parties);
+		while (connections == null) {
+			try {
+				connections = connectionfactory.connect(parties);
+			} catch (NoResourcesNowException e) {
+				long waitms = e.getLater().getTime()
+						- System.currentTimeMillis();
+				log.log(Level.INFO,
+						"No resources available to run session, waiting"
+								+ waitms);
+				Thread.sleep(Math.min(MAX_SLEEP_TIME,
+						Math.max(MIN_SLEEP_TIME, waitms)));
+			}
+		}
+		for (int i = 0; i < participants.size(); i++) {
+			conns = conns.with(connections.get(i));
+			setState(this.state.with(connections.get(i).getParty(),
+					participants.get(i)));
+		}
+	}
+
+	/**
+	 * This is called when one of the party connections does an action.
+	 * Synchronized so that we always handle only 1 action at a time.
+	 * 
+	 * @param partyconn the connection on which the action came in.
+	 * @param action    the {@link Action} taken by some party
+	 */
+	protected synchronized void actionRequest(
+			final ProtocolToPartyConn partyconn, final Action action) {
+		if (action == null) {
+			Throwable err = partyconn.getError();
+			if (err == null) {
+				err = new ProtocolException("Party sent a null action",
+						partyconn.getParty());
+			}
+			handleError(partyconn + "Protocol error", partyconn.getParty(),
+					err);
+			return;
+		}
+
+		try {
+			setState(state.with(partyconn.getParty(), action));
+		} catch (Throwable e) {
+			handleError("failed to handle action " + action,
+					partyconn.getParty(), e);
+		}
+
+	}
+
+	/**
+	 * step 2 in protocol: listen to connections and send settings to the
+	 * parties.
+	 * <p>
+	 * This is 'protected' to allow junit testing, this code is not a 'public'
+	 * part of the interface.
+	 * 
+	 * @throws ProtocolException if a party does not follow the protocol
+	 */
+	protected synchronized void setupParties() throws ProtocolException {
+		for (ProtocolToPartyConn conn : conns) {
+			conn.addListener(action -> actionRequest(conn, action));
+		}
+
+		for (ProtocolToPartyConn connection : conns) {
+			try {
+				sendSettings(connection);
+			} catch (IOException e) {
+				throw new ProtocolException("Failed to initialize",
+						connection.getParty(), e);
+			}
+		}
+
+	}
+
+	/**
+	 * Inform a party about its settings
+	 * 
+	 * @param connection
+	 * @throws IOException if party got disconnected
+	 */
+	private synchronized void sendSettings(ProtocolToPartyConn connection)
+			throws IOException {
+		PartyId partyid = connection.getParty();
+		ProfileRef profile = state.getPartyProfiles().get(partyid).getProfile();
+		Parameters params = state.getPartyProfiles().get(partyid).getParty()
+				.getParameters();
+		if (profile == null) {
+			throw new IllegalArgumentException(
+					"Missing profile for party " + connection.getReference());
+		}
+		connection.send(new Settings(connection.getParty(), profile, getRef(),
+				state.getProgress(), params));
+	}
+
+	/**
+	 * Set state to proper deadline. Starts the timer tasks. This tasks triggers
+	 * a call to handleError when the session times out.
+	 */
+	private synchronized void setDeadline() {
+		long now = System.currentTimeMillis();
+		Deadline deadline = state.getSettings().getDeadline();
+		setState(state.with(ProgressFactory.create(deadline, now)));
+		deadlinetimer = new Timer();
+		TimerTask task = new TimerTask() {
+			@Override
+			public void run() {
+				if (!state.isFinal(System.currentTimeMillis())) {
+					log.log(Level.SEVERE,
+							"BUG. Deadline timer has triggered but state is not final");
+				}
+				log.log(Level.WARNING,
+						"SAOP deadline reached. Terminating session.");
+				finish();
+			}
+		};
+		// set timer TIME_MARGIN after real deadline to ensure we're not too
+		// early
+		deadlinetimer.schedule(task, deadline.getDuration() + TIME_MARGIN);
+		log.log(Level.INFO, "SAOP deadline set to "
+				+ new SimpleDateFormat("yyyy/MM/dd HH:mm:ss")
+						.format(new Date(System.currentTimeMillis()
+								+ deadline.getDuration() + TIME_MARGIN)));
+	}
+
+	/**
+	 * Update state to include the given error and finishes up the session.
+	 * 
+	 * @param message The message to attach to the error
+	 * @param party   the party where the error occured
+	 * @param e       the exception that occured.
+	 */
+	private synchronized void handleError(final String message,
+			final PartyId party, final Throwable e) {
+		if (e instanceof ProtocolException) {
+			setState(state.with((ProtocolException) e));
+		} else {
+			setState(state.with(new ProtocolException(message, party, e)));
+		}
+		log.log(Level.WARNING, "SAOP protocol intercepted error due to party "
+				+ party + ":" + message, e);
+	}
+
+	/**
+	 * Sets the new state. If the new state is final, the finish-up procedure is
+	 * executed.
+	 * 
+	 * @param newstate the new state.
+	 */
+	private synchronized void setState(LearnState newstate) {
+		long now = System.currentTimeMillis();
+		if (state.isFinal(now)) {
+			finish();
+			return;
+		}
+		this.state = newstate;
+		if (newstate.isFinal(now)) {
+			finish();
+		}
+	}
+
+	/**
+	 * Called when we reach final state. Cancels deadline timer. Send finished
+	 * info to all parties, notify current nego state as final and set
+	 * {@link #isFinishedInfoSent}. Double calls are automatically ignored.
+	 */
+	private synchronized void finish() {
+		if (deadlinetimer != null) {
+			deadlinetimer.cancel();
+			deadlinetimer = null;
+		}
+		if (!isFinishedInfoSent.compareAndSet(false, true))
+			return;
+		Inform finished = new Finished(state.getAgreements());
+		for (ProtocolToPartyConn conn : conns) {
+			sendFinish(conn, finished);
+		}
+		notifyListeners(new CurrentNegoState(state));
+	}
+
+	private void sendFinish(ProtocolToPartyConn connection, Inform finished) {
+		try {
+			connection.send(finished);
+			connection.close();
+		} catch (Exception e) {
+			log.log(Level.INFO, "Failed to send Finished to " + connection, e);
+		}
+	}
+}
Index: protocol/src/main/java/geniusweb/protocol/session/learn/LearnSettings.java
===================================================================
--- protocol/src/main/java/geniusweb/protocol/session/learn/LearnSettings.java	(revision 31)
+++ protocol/src/main/java/geniusweb/protocol/session/learn/LearnSettings.java	(revision 31)
@@ -0,0 +1,181 @@
+package geniusweb.protocol.session.learn;
+
+import java.util.Collections;
+import java.util.LinkedList;
+import java.util.List;
+import java.util.UUID;
+import java.util.stream.Collectors;
+
+import com.fasterxml.jackson.annotation.JsonCreator;
+import com.fasterxml.jackson.annotation.JsonProperty;
+import com.fasterxml.jackson.databind.ObjectMapper;
+
+import geniusweb.actions.FileLocation;
+import geniusweb.deadline.Deadline;
+import geniusweb.protocol.session.SessionProtocol;
+import geniusweb.protocol.session.SessionSettings;
+import geniusweb.protocol.session.TeamInfo;
+import geniusweb.protocol.session.saop.SAOPSettings;
+import geniusweb.references.Parameters;
+import geniusweb.references.PartyWithProfile;
+import tudelft.utilities.logging.Reporter;
+
+/**
+ * Settings for learn protocol.
+ */
+public class LearnSettings implements SessionSettings {
+	private final List<TeamInfo> participants;
+	private final Deadline deadline;
+
+	private final static ObjectMapper jackson = new ObjectMapper();
+
+	/**
+	 * 
+	 * @param participants the list of {@link PartyWithProfile} in clockwise
+	 *                     order. There must be at least 2 to run the SAOP
+	 *                     protocol. But SAOP can be initialized with less, for
+	 *                     use in TournamentSettings.
+	 *                     <table>
+	 *                     <caption>Required parameters</caption>
+	 *                     <tr>
+	 *                     <td>persistentstate</td>
+	 *                     <td>a {@link FileLocation}, serialized as json eg
+	 *                     <code>"b29f3bf5-1dc4-499e-a676-7b2dbb864a03"</code> ,
+	 *                     where the party's persistant state is stored; this
+	 *                     must match the persistantstate used in earlier calls
+	 *                     for e.g. {@link SAOPSettings}.</td>
+	 *                     </tr>
+	 * 
+	 *                     <tr>
+	 *                     <td>negotiationdata</td>
+	 *                     <td>a List of {@link FileLocation}s, serialized as
+	 *                     json, matching the negotiationdata used in earlier
+	 *                     calls for eg {@link SAOPSettings}.</td>
+	 *                     </tr>
+	 *                     </table>
+	 * @param deadline     the deadline of the negotiation.
+	 */
+	@SuppressWarnings("unused")
+	@JsonCreator
+	public LearnSettings(
+			@JsonProperty("participants") List<TeamInfo> participants,
+			@JsonProperty("deadline") Deadline deadline) {
+		this.participants = participants;
+		this.deadline = deadline;
+		if (participants == null) {
+			throw new IllegalArgumentException("participants must not be null");
+		}
+		if (deadline == null) {
+			throw new IllegalArgumentException("deadline must not be null");
+		}
+
+		for (PartyWithProfile pwithp : getAllParties()) {
+			Parameters params = pwithp.getParty().getParameters();
+			Object statestr = params.get("persistentstate");
+			if (!(statestr instanceof String))
+				throw new IllegalArgumentException(
+						"persistentstate parameter containing UUID string is required, but found "
+								+ statestr);
+			// check that it contains a UUID. Don't store it, we don't need
+			// it.
+			UUID.fromString((String) statestr);
+
+			// and check the negotiationdata
+			Object negotiationsstr = params.get("negotiationdata");
+			if (!(negotiationsstr instanceof List))
+				throw new IllegalArgumentException(
+						"negotiationdata parameter containing a List is required");
+
+			for (Object negostr : (List) negotiationsstr) {
+				if (!(negostr instanceof String))
+					throw new IllegalArgumentException(
+							"The list in negotiationdata must contain UUID strings but found "
+									+ negostr);
+				UUID.fromString((String) negostr);
+			}
+		}
+	}
+
+	@Override
+	public Double getMaxRunTime() {
+		return deadline.getDuration() / 1000d;
+	}
+
+	@Override
+	public SessionProtocol getProtocol(Reporter logger) {
+		return new Learn(new LearnState(this), logger);
+	}
+
+	@Override
+	public List<TeamInfo> getTeams() {
+		return Collections.unmodifiableList(participants);
+	}
+
+	/**
+	 * @return the deadline for this negotiation
+	 */
+	public Deadline getDeadline() {
+		return deadline;
+	}
+
+	@Override
+	public List<PartyWithProfile> getAllParties() {
+		return participants.stream()
+				.map(particip -> particip.getAllParties().get(0))
+				.collect(Collectors.toList());
+	}
+
+	@Override
+	public Integer getTeamSize() {
+		return 1;
+	}
+
+	@Override
+	public String toString() {
+		return "LearnSettings" + participants + "," + deadline + "]";
+	}
+
+	@Override
+	public int hashCode() {
+		final int prime = 31;
+		int result = 1;
+		result = prime * result
+				+ ((deadline == null) ? 0 : deadline.hashCode());
+		result = prime * result
+				+ ((participants == null) ? 0 : participants.hashCode());
+		return result;
+	}
+
+	@Override
+	public boolean equals(Object obj) {
+		if (this == obj)
+			return true;
+		if (obj == null)
+			return false;
+		if (getClass() != obj.getClass())
+			return false;
+		LearnSettings other = (LearnSettings) obj;
+		if (deadline == null) {
+			if (other.deadline != null)
+				return false;
+		} else if (!deadline.equals(other.deadline))
+			return false;
+		if (participants == null) {
+			if (other.participants != null)
+				return false;
+		} else if (!participants.equals(other.participants))
+			return false;
+		return true;
+	}
+
+	@Override
+	public SessionSettings with(TeamInfo team) {
+		if (team.getSize() != 1)
+			throw new IllegalArgumentException(
+					"Team must be size 1 but found " + team);
+		List<TeamInfo> newparts = new LinkedList<>(participants);
+		newparts.add(team);
+		return new LearnSettings(newparts, deadline);
+	}
+
+}
